var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class ThrottleAsyncExecutor {
    constructor(fun, parallelCalls) {
        this.fun = fun;
        this.parallelCalls = parallelCalls;
        this.onGoingCallsCount = 0;
        this.lastProm = Promise.resolve(null);
    }
    exec(context, args) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.onGoingCallsCount < this.parallelCalls) {
                this.lastProm = this.handlePromise(this.fun.apply(context, args));
            }
            else {
                this.lastProm = this.lastProm
                    .then(() => this.handlePromise(this.fun.apply(context, args)))
                    .catch(() => this.handlePromise(this.fun.apply(context, args)));
            }
            return this.lastProm;
        });
    }
    handlePromise(promise) {
        return __awaiter(this, void 0, void 0, function* () {
            this.onGoingCallsCount += 1;
            return promise
                .finally(() => {
                this.onGoingCallsCount -= 1;
            });
        });
    }
}
//# sourceMappingURL=throttle-async-executor.js.map